Newsgroups: comp.databases,comp.databases.theory,comp.lang.java.databases,comp.lang.java.programmer
From: mikito Harakiri <nospam@newsranger.com>
References: <9c4urh$2th$04$1@news.t-online.com> <3AEA1B84.3525@ix.netcom.com> <9cefv8$rb6$00$1@news.t-online.com> <3AEB2DB6.164F@ix.netcom.com> <9cgt8i$iqd$07$1@news.t-online.com> <3AED21D5.7597@ix.netcom.com> <9cjfdg$j8q$01$1@news.t-online.com> <3AF06D8A.5D26@ix.netcom.com> <9cq087$dke$07$1@news.t-online.com> <3AF321CF.5E4D@ix.netcom.com> <9cvc5b$7ce$07$1@news.t-online.com> <3AF63030.5DF7@ix.netcom.com> <9d5nol$pua$06$1@news.t-online.com> <3AF7B5DF.7784@ix.netcom.com> <9d8nkr$mj$02$1@news.t-online.com> <4BVJ6.6342$vg1.497034@www.newsranger.com> <9d99ik$reg$02$1@news.t-online.com> <tVWJ6.6547$vg1.512434@www.newsranger.com> <9d9i7n$3j4$03$1@news.t-online.com>
Subject: Re: S.O.D.A. database Query API - call for comments
Lines: 72
Message-ID: <jk_J6.6868$vg1.552623@www.newsranger.com>
X-Abuse-Info: When contacting newsranger.com regarding abuse please
X-Abuse-Info: forward the entire news article including headers or
X-Abuse-Info: else we will not be able to process your request
X-Complaints-To: abuse@newsranger.com
NNTP-Posting-Date: Tue, 08 May 2001 18:22:07 EDT
Organization: http://www.newsranger.com
Date: Tue, 08 May 2001 22:22:07 GMT


In article <9d9i7n$3j4$03$1@news.t-online.com>, Carl Rosenberger says...
>
>mikito Harakiri wrote:
>> Ok, let object Car contain Wheel (4 fields, actually:-). How exactly would
 I
>> find a Car given a Wheel; what indexes would I use? (Note that sql folks
 are
>> eager to provide exact sql statements -- I would like to see the code for
>> objects either:-)
>
>This is the "right-way-around" in a declarative query to an object database.
>Note that declarative queries and object navigation are beautifully
>complementary:
>- navigation in the programming language finds members of objects
>- declarative queries constrain objects by their members
>
>Code according to the current S.O.D.A. spec:
>
>// your class model
>class Wheel{
>}
>
>class Car{
>   Wheel[] wheels;
>}
>
>ObjectContainer db;
>Wheel myWheel;
>
>Query carNode = db.query();
>carNode.constrain(new Car());
>carNode.getSubNode("wheels").constrain(myWheel).identity();
>ObjectSet res = carNode.execute();

Hmm, not bad... I mean, at least, that's something to discuss. Minor stylistic
suggestion:

carNode.constrain(Car.class);

How about finding all red cars with alloy wheels? 

class Car{
Wheel[] wheels;
Color   color;
}

class Wheel {
boolean isAlloy;
}

Query carNode = db.query();
carNode.constrain(new Car());
carNode.getSubNode("color").constrain(new Color("red"));
carNode.getSubNode("wheels")
getSubNode("isAlloy").constrain(new Boolean(true));
ObjectSet res = carNode.execute();

I somehow feel that this type of query has a lower abstraction level (it looks
similar to a plan for sql execution) but I don't seem to be able to prove my
position. Hope that relational folks would be able to criticise it more
specifically (apart from usual "codasyl/no pointers allowed" cliche)

>Your question "what indexes would I use?" only needs to be answered for
>relational databases. We are using objects. There is no need for keys to
>join objects.

Actually, indexes could be hidden in so called "self-tuned" relational database,
so that user don't even have to be aware of them. In your approach you probably
will use indexes behind the scene when Cars pool grows significantly, therefore,
there is not much differences there.



